<?php
/**
 * FeedGeorge main class
 * 
 * @package FeedGeorge_Wordpress_PLUGIN
 * @author CH Foo
 * @copyright 2011 FeedGeorge.com
 * @access public
 */

class WP_FGgeo {
    
	//private $fgmarkercount = 0;
	private $fgshowmap = false;
	private $fgplace;
    private $fgeo_options = null;
    private $smallmarker;
			
	
    public function WP_FGgeo() {
       global $fg_admin, $fg_ajax;
       
	    $this->init();
		
        add_action( 'init', array( &$this, 'init' ) );
		
        add_action( 'wp', Array( &$this, 'load_script' ) );
        add_action( 'wp_head', Array( &$this, 'load_head' ) );
		
		add_action('wp_ajax_call_ajax', Array(&$fg_ajax,'call_ajax'));
        add_action('wp_ajax_nopriv_call_ajax', Array(&$fg_ajax,'call_ajax'));
		
		add_action('wp_ajax_save_poly', Array(&$this,'save_poly'));
        add_action('wp_ajax_nopriv_save_poly', Array(&$this,'save_poly'));
        
		add_action('wp_ajax_exportKMLFile', Array(&$fg_ajax,'exportKMLFile'));
        add_action('wp_ajax_nopriv_exportKMLFile', Array(&$fg_ajax,'exportKMLFile'));
		
		add_action('wp_ajax_readKMLFile', Array(&$fg_ajax,'readKMLFile'));
        add_action('wp_ajax_nopriv_readKMLFile', Array(&$fg_ajax,'readKMLFile'));
		
        add_action( 'admin_head', array( &$fg_admin, 'admin_head' ) );
		add_filter( 'the_content', array( &$this, 'the_content' ) );
		add_filter( 'the_title', array( &$this, 'the_title' ) );
        
		//Register widgets
		add_action('widgets_init', Array(&$this,'register_widgets'));  
        
		$this->fgplace = Array();
        
    }
    
    function load_head() {
        
		$front_geomap['latitude'] = (empty($this->fgeo_options['front_map_latitude']))? FG_MAP_LAT : $this->fgeo_options['front_map_latitude'] ;
		$front_geomap['longitude'] = (empty($this->fgeo_options['front_map_longitude']))? FG_MAP_LNT : $this->fgeo_options['front_map_longitude']  ;
		$front_geomap['map_zoom'] = (empty($this->fgeo_options['front_map_zoom']))? FG_MAP_ZOOM : $this->fgeo_options['front_map_zoom'];
		$front_geomap['marker_icon'] = $this->get_marker_image(FG_MAP_MARKER);
		$front_geomap['dir'] = FG_REL_URL;
        $front_geomap['home'] = home_url();
	
		
		if(isset($this->fgeo_options['isHeatmap']) && $this->fgeo_options['isHeatmap'] == 1) {
			$front_geomap['isHeatmap'] = 1;
		}
		
		if(isset($this->fgeo_options['isPoly']) && $this->fgeo_options['isPoly'] == 1 && is_user_logged_in() && current_user_can( 'edit_posts' )) {
			$front_geomap['isPoly'] = 1;
			
			if ($this->fgeo_options['isPoly'] == 1) {
				$front_geomap['heattype_opt'] = $this->fgeo_options['heattype_setting'];
			}
		}
		
		
		echo '<script type="text/javascript">var fg_default_map = '.json_encode($front_geomap).';</script>';
	
    }
	
	
    public function init() {
        
        $this->fgeo_options = get_option("_FGEORGE_GEOLOCATION_OPTION");
		$this->smallmarker = $this->get_marker_image(FG_MAP_SMALL_MARKER);
    }
	
	public function save_poly() {
		global $fg_ajax;
		
		if ( isset( $_POST['fg_noncename'] ) && !wp_verify_nonce( $_POST['fg_noncename'], plugin_basename( __FILE__ ) ) ) {
			echo -1;
			exit;
		}
		else 
			$fg_ajax->save_poly();
	}
    
    
    public function get_marker_image($filename) {
        $upload = wp_upload_dir();
        
        $default_marker = FG_IMG_URL . '/'.$filename;
        $user_marker = $upload['baseurl'] .'/wp-feedgeorge/'. $filename;
        
        if (is_readable($user_marker)) {
            $marker = $user_marker;
        }
        else
            $marker = $default_marker;
        
        return $marker;
    }
	
	
	public function the_title($title = '') {
		global $post;
		$newtitle = '';
        
		if (is_home() && in_the_loop() && $this->fgshowmap == true && $post->post_status == 'publish') {
			
			$geolocation = get_post_meta($post->ID, FGEORGE_GEOLOCATION, true);
			$geokml = get_post_meta($post->ID, FGEORGE_KMLFILE,true);
			
			if (isset($geokml)) {
				$uploads = wp_upload_dir();
				$filename = FG_KML_DIR .'/wpfg_'. $post->ID .'.kml';
				
				$kmlfile = $uploads['baseurl'] . $filename;
				if (file_exists($uploads['basedir'] . $filename)) {
					$kml = json_encode(array($post->post_title,$kmlfile));
					$kml_str = 'kmllist.push('.$kml.');';
				}
			}
			
			if (is_numeric($geolocation['latitude']) && is_numeric($geolocation['longitude']) ) {
				
					$address = $geolocation[address];
					$postcode = $geolocation[postcode];
					$town = $geolocation[town];
					$latitude = $geolocation['latitude'];
					$longitude = $geolocation['longitude'];
                   
					
					$location = $address . ' ' .$postcode . ' ' .$town;
					$info = '<div id="fg_map_info"><a href="'.get_permalink().'">'.$post->post_title.'</a><p>'.$location .'<br/><a href="'.get_permalink().'">Detail</a></p></div>';
					
					
					
					$pointer = '<span class="fg_map_icon" style="background: url('.$this->smallmarker.') top center no-repeat;"></span>';
					
					$place = json_encode(array($post->post_title,$latitude,$longitude," ",$info));
					$place_str = 'geoplace.push('.$place.');';
				
			}
			
			
			$newtitle = '<script>'.$place_str.$kml_str.'</script>';
			$title = $pointer . $title . $newtitle;
			
		}
		
		return $title;
	}	
	
	
	public function the_content($content = '') {
		global $post;
		$showmap = false;
		
		if (!is_feed() && is_single()) {
			$geolocation = get_post_meta($post->ID, FGEORGE_GEOLOCATION, true);
			
			if ($geolocation && is_numeric($geolocation['latitude']) && is_numeric($geolocation['longitude'])) {
				$address = $geolocation[address];
				$postcode = $geolocation[postcode];
				$town = $geolocation[town];
				$latitude = $geolocation['latitude'];
				$longitude = $geolocation['longitude'];
                $maptype = $geolocation['maptype'];
                $use_custom_zoom = $geolocation['use_custom_zoom'];
                
                
                if ($use_custom_zoom == 1 && $geolocation['zoom'] > 0)
                    $zoom =  $geolocation['zoom'];
                else
                    $zoom = $this->fgeo_options['post_map_zoom'];
				
				$location = $address . ' ' .$postcode . ' ' .$town;
				
				
				$fglocation = 'var fglocation = ' .json_encode(Array('postlat'=>$latitude, 'postlng'=>$longitude, 'postzoom'=>$zoom,'postmaptype'=>$maptype)).';';
				$showmap = true;
			}
			
			if( $this->fgeo_options['isPoly'] == 1) {
				//$fglocation = 'var fglocation = null;';
				if ($kml = $this->get_kml_url($post->ID)) {
					$fgkmllink = $kml;
					$showmap = true;
				    $fglocation = 'var fglocation = null;';
				}
			}
				
			if ($showmap) {
				if (empty($this->fgeo_options['post_map_height']))
					$this->fgeo_options['post_map_height'] = FG_MAP_HEIGHT;
				
				if (empty($this->fgeo_options['post_map_width']))
					$width = '100%';
				else
					$width = $this->fgeo_options['post_map_width'] . 'px';

				$new_content .= '
				<div class="fgeo_post_location">'.$location.'</div>
				<div class="fgeo_post_map" id="fgeo_postmap_' . $post->ID . '" style="width:'.$width.'; height:' . $this->fgeo_options['post_map_height'] . 'px;"></div>
				<script>
					'.$fglocation.'
					var fgkmlfile ="'.$fgkmllink.'";
					fgeo_post_map.init('.$post->ID.',"'.$post->post_title.'")
				</script>
				';

				// Run HTML through filter
				$new_content = apply_filters( 'fgeorge_thecontent', $new_content );

			}
			
		}
		
		$content = $content . $new_content;
		
		return $content;
	}
	
	
	private function get_kml_url($postid) {
		
		if ($this->fgeo_options['isPoly'] == 1) {
			$uploads = wp_upload_dir();
			$filename = FG_KML_DIR .'/wpfg_'. $postid .'.kml';
			
			$kmlfile = $uploads['baseurl'] . $filename;
			if (file_exists($uploads['basedir'] . $filename)) {
				return $kmlfile;
			}
		}
		
		return false;
	}
	
	
	
	public function get_map($height = 300) {

		$this->fgshowmap = true;
		
		//$fgeo_options = get_option("_FGEORGE_GEOLOCATION_OPTION");
		if (empty($this->fgeo_options['front_map_height']))
			$this->fgeo_options['front_map_height'] = FG_MAP_HEIGHT;
				
		if (empty($this->fgeo_options['front_map_width']))
			$width = '100%';
		else
			$width = $this->fgeo_options['front_map_width'] . 'px';
		
		$maphtml = '<div id="fgeorge_map" style="width:'.$width.'; height:'.$this->fgeo_options['front_map_height'].'px">Loading ... </div>';
		
		if ($this->fgeo_options['isPoly'] == 1 && is_user_logged_in() && current_user_can( 'edit_posts' )) {
			$maphtml .= $this->get_polytooldiv();
		}
		
		return $maphtml;
	}
	
	
	function get_polytooldiv() {
		
		$poly = array(
			'strokeColor' => "#FF0000",
			'strokeOpacity' => 0.8,
			'strokeWeight' => 2,
			'fillColor' => "#FF0000",
			'fillOpacity' => 0.3,
			'distance' => 500,
		);
		
		$fgeo_options = $this->fgeo_options;
		
		if($fgeo_options['isPoly'] == 1) { 
			
			$poly = $fgeo_options['heattype_setting'];
		}
		
		$form = '
		<div id="embed_tab" class="fg_poly_tab">
			<li onclick="_fgpolytab(\'fgpoform\')">Draw Polygon</li>
			<li onclick="_fgpolytab(\'kmluploadfrm\')">Upload KML</li>
		</div>
		<div id="poly_form" class="fg_polytool" style="display:none">
				 <form id="fgpoform" class="poform">
					<li>
						<h2>Draw Polygon [<a href="#" onclick="jQuery(\'#posetup\').show();return false;">Setting</a>]</h2>
						<input type="hidden" id="fgkmldata" name="fgkmldata" value="" />
						<input type="hidden" id="fgkml" name="fgkml" value="" />
						<input type="hidden" name="fg_noncename" id="fg_noncename" value="'.wp_create_nonce(plugin_basename(__FILE__)).'" />
						<label for="ptitle">Title:</label><input type="text" id="ptitle" name="ptitle" value="Polygron 1" /><br/>
						<label for="pdesc">Description</label><br/><textarea id="pdesc" name="pdesc"></textarea><br/>
					</li>
					<li class="btn">
						<input type="button" id="saveBtn" value="Save" class="btn" /><br/><input type="button" id="clearBtn" value="clear"  class="btn" />
					</li>
				</form>
				<iframe id="upload_target" name="upload_target" style="height:5px;display:none" ></iframe>
				<form id="kmluploadfrm" enctype="multipart/form-data" style="display:none" class="poform" method="POST">
					<h2>Upload KML File</h2>
					<input type="hidden" name="fg_noncename" id="fg_noncename" value="'.wp_create_nonce(plugin_basename(__FILE__)).'" />
					<input type="hidden" name="act" id="act" value="upload-kml" />
					<input type="file" id="fgkmlfile" name="fgkmlfile" /><br/>
					<label for="ptitle">Title:</label>: <input type="text" id="ptitle" name="ptitle" value="Polygron 1" /><br/>
					<label for="pdesc">Description:</label><br/> <textarea id="pdesc" name="pdesc"></textarea><br/>
					<input type="button" id="uploadBtn" value="Save" class="btn" />
				</form>
				
		    <div id="posetup" style="display:none">
				<form id="fgposetupform">
				<label for="poly_strokecolor">stroke Color</label> <input type="text" name="poly[strokeColor]" class="color {hash:true}" id="poly_strokecolor" value="'.$poly[strokeColor].'" />
				<label for="poly_strokeopacity">stroke Opacity</label> <select name="poly[strokeOpacity]" id="poly_strokeopacity" >'.show_op_list($poly[strokeOpacity],true).'</select>
				<label for="poly_strokeweight">stroke Weight</label> <input type="text" name="poly[strokeWeight]" id="poly_strokeweight" value="'.$poly[strokeWeight].'" /><br/>
				<label for="poly_fillcolor">fill Color</label> <input type="text" name="poly[fillColor]" id="poly_fillcolor" value="'.$poly[fillColor].'" class="color {hash:true}" />
				<label for="poly_fillopacity">fillOpacity</label> <select name="poly[fillOpacity]" id="poly_fillopacity">'.show_op_list($poly[fillOpacity],true).'</select><br/>
				<input type="button" id="saveSettingBtn" value="Change" class="btn" /> <input type="button" id="resetBtn" value="Reset" class="btn" /> <input type="button" id="clearBtn" value="Cancel"  class="btn" onclick="jQuery(\'#posetup\').hide()"/>
				
				</form>
			</div>
		</div>';
		
		return $form;
	}
    
    function register_widgets() {
		register_widget('feedgeorgeMapWidget');
	}
	
    function fg_main_pages( $template ) {
		global $post;
		
		
		return $template;
	}
    
    public function get_options() {
        return $this->fgeo_options;
    }
    
    
    public function init_plugin() {
    }
    
    public function kill_plugin() {
    }
    
    public function load_script() {
        
		wp_enqueue_style('fgeorge_css', FG_CSS_URL.'/fg_style.css');
		
		wp_enqueue_script('jquery');
		wp_enqueue_script('GoogleMaps','http://maps.google.com/maps/api/js?sensor=false');
	   
		wp_enqueue_script('fg_map_script', FG_JS_URL . '/front_map.js');
		wp_enqueue_script('fg_map_script', FG_JS_URL . '/fg_script.js');
		
		if(is_single())
			wp_enqueue_script('fg_map_nearby_script', FG_JS_URL . '/fg_nearbymap.js');
		
		if($this->fgeo_options['isPoly'] == 1) {
			wp_enqueue_script('fg_map_script2', FG_JS_URL . '/polytool.js');
			wp_enqueue_script('fg_color', FG_JS_URL . '/jscolor.js');
		}
        
    }
    
}





?>